import { MAIN_SOURCE_ID } from "./setting";
import { FindCapacity, GetConstructureSet, GetSource } from "./util";

export function Build(creep: Creep, structureType: string | null = null) {
    if (creep.memory.working && creep.store[RESOURCE_ENERGY] == 0) {
        creep.memory.working = false;
        creep.say("harvest")
    }
    if (!creep.memory.working && creep.store.getFreeCapacity(RESOURCE_ENERGY) == 0) {
        creep.memory.working = true
        creep.say("builder")
    }
    if (creep.memory.working) {
        let target = GetConstructureSet(creep, structureType);
        if (target.length > 0) {
            if (creep.build(target[0]) == ERR_NOT_IN_RANGE) {
                creep.moveTo(target[0], { visualizePathStyle: { stroke: "#ffaa00" } });
            }
        } else {
            let targets = FindCapacity(creep);
            if (targets.length > 0) {
                target.sort();
                if (creep.transfer(targets[0], RESOURCE_ENERGY) == ERR_NOT_IN_RANGE) {
                    creep.moveTo(targets[0], { visualizePathStyle: { stroke: "#ffaa00" } });
                }
            }
        }
    } else {
        creep.memory.working = false
        let source = GetSource(MAIN_SOURCE_ID);
        if (creep.harvest(source) == ERR_NOT_IN_RANGE) {
            creep.moveTo(source, { visualizePathStyle: { stroke: "#ffaa00" } });
        }
    }
}