import { FindCapacity, GetSource } from "./util"
import { MAIN_SOURCE_ID } from "./setting";

export function Harvest(creep: Creep) {
    if (creep.store.getFreeCapacity() > 0) {
        let source: Source = GetSource(MAIN_SOURCE_ID);
        if (creep.harvest(source) == ERR_NOT_IN_RANGE) {
            creep.moveTo(source, { visualizePathStyle: { stroke: "#ffaa00" } });
        }
    } else {
        let targets = FindCapacity(creep);
        if (targets.length > 0) {
            if(creep.transfer(targets[0], RESOURCE_ENERGY) == ERR_NOT_IN_RANGE){
                creep.moveTo(targets[0], { visualizePathStyle: { stroke: "#ffffff" } });
            }
        }
    }
}