import "./setting";
import { BUILDER_COUNT, HARVESTER_COUNT, UPGRADER_COUNT } from "./setting";

var createDefaultHarvester = (spawn: StructureSpawn) => {
    let name = "Harvester" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, {
        memory: {
            role: "Harvester",
            working: false
        }
    });
}
var createDefaultBuilder = (spawn: StructureSpawn) => {
    let name = "Builder" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, {
        memory: {
            role: "Builder",
            working: false
        }
    });
}

var createDefaultUpgrader = (spawn: StructureSpawn) => {
    let name = "Upgrader" + Game.time;
    return spawn.spawnCreep([WORK, CARRY, MOVE], name, {
        memory: {
            role: "Upgrader",
            working: false
        }
    });
}

export function SpawnCreep(spawn: StructureSpawn) {
    if (spawn.spawning) return;


    let harvesters = _.filter(Game.creeps,
        /**@param {Creep} creep*/
        (creep) => {
            return creep.memory.role == "Harvester";
        });
    let builders = _.filter(Game.creeps,
        /**@param {Creep} creep*/
        (creep) => {
            return creep.memory.role == "Builder";
        });
    let upgraders = _.filter(Game.creeps,
        /**@param {Creep} creep*/
        (creep) => {
            return creep.memory.role == "Upgrader";
        });
    if (harvesters.length < HARVESTER_COUNT) {
        if (createDefaultHarvester(spawn) == 0) {
            console.log("Spawn Harvester")
        }
    }
    if (upgraders.length < UPGRADER_COUNT) {
        if (createDefaultUpgrader(spawn) == 0) {
            console.log("Spawn Upgrader")
        }
    }
    if (builders.length < BUILDER_COUNT) {
        if (createDefaultBuilder(spawn) == 0) {
            console.log("Spawn Builder")
        }
    }

    if (spawn.spawning) {
        var spawningCreep = Game.creeps[spawn.spawning.name];
        spawn.room.visual.text(
            '🛠️' + spawningCreep.memory.role,
            spawn.pos.x + 1,
            spawn.pos.y,
            { align: 'left', opacity: 0.8 });
    }
}